Package: savR
Type: Package
Title: Parse and analyze Illumina SAV files
Version: 1.28.0
Date: 2015-07-28
Author: R. Brent Calder
Maintainer: R. Brent Calder <brent.calder@einstein.yu.edu>
Description: Parse Illumina Sequence Analysis Viewer (SAV) files,
    access data, and generate QC plots.
License: AGPL-3
URL: https://github.com/bcalder/savR
BugReports: https://github.com/bcalder/savR/issues
Depends: ggplot2
Imports: methods, reshape2, scales, gridExtra, XML
Suggests: Cairo, testthat
biocViews: Sequencing
git_url: https://git.bioconductor.org/packages/savR
git_branch: RELEASE_3_12
git_last_commit: b051b0b
git_last_commit_date: 2020-10-27
Date/Publication: 2020-10-27
NeedsCompilation: no
Packaged: 2020-10-28 03:08:14 UTC; biocbuild

savR
================================

*savR* is an R package to parse Illumina Sequence Analysis Viewer (InterOp)
files for downstream analysis.

Current release version 1.7.5.

Example
--------

```
library(savR)
example(savR)
```

# @include savR.R
NULL

#'@rdname savR
#@aliases savR,character-method
setMethod("savR", signature("character"), function(object) {
  retval <- new("savProject", location=normalizePath(object))
  retval@cycles <- 0L
  retval@directions <- 0L
  ri <- normalizePath(paste(object, "RunInfo.xml", sep="/"))
  runinfo <- XML::xmlInternalTreeParse(ri)
  retval@runid <- XML::xmlAttrs(XML::xpathApply(runinfo, "/RunInfo/Run")[[1]])["Id"]
  retval@number <- as.integer(XML::xmlAttrs(xpathApply(runinfo, "/RunInfo/Run")[[1]])["Number"])
  retval@flowcell <- XML::xmlValue(XML::xpathApply(runinfo, "/RunInfo/Run/Flowcell")[[1]])
  retval@instrument <- XML::xmlValue(XML::xpathApply(runinfo, "/RunInfo/Run/Instrument")[[1]])
  retval@date <- XML::xmlValue(XML::xpathApply(runinfo, "/RunInfo/Run/Date")[[1]])
  reads <- c()
  for (x in XML::xpathApply(runinfo, "/RunInfo/Run/Reads/Read")) {
    index <- XML::xmlAttrs(x)["IsIndexedRead"]
    index <- if(index=="Y") T else F
    read <- new("illuminaRead", number=as.integer(XML::xmlAttrs(x)["Number"]), 
                cycles=as.integer(XML::xmlAttrs(x)["NumCycles"]),
                index=index)
    reads <- c(reads, read)
    retval@cycles <- retval@cycles + read@cycles
    if (!read@index)
      retval@directions <- retval@directions + 1L
  } 
  retval@reads <- reads
  layout <- XML::xpathApply(runinfo, "/RunInfo/Run/FlowcellLayout")[[1]]
  layoutChildren <- XML::xmlChildren(layout)
  tnc <- ""
  if (length(layoutChildren) > 0) {
    tnc <- XML::xmlAttrs(layoutChildren$TileSet)["TileNamingConvention"]
  }
  retval@layout <- new("illuminaFlowCellLayout", lanecount=as.integer(XML::xmlAttrs(layout)["LaneCount"]),
                       surfacecount=as.integer(XML::xmlAttrs(layout)["SurfaceCount"]),
                       swathcount=as.integer(XML::xmlAttrs(layout)["SwathCount"]),
                       tilecount=as.integer(XML::xmlAttrs(layout)["TileCount"]),
                       sectionperlane=as.integer(XML::xmlAttrs(layout)["SectionPerLane"]),
                       lanepersection=as.integer(XML::xmlAttrs(layout)["LanePerSection"]),
                       tilenamingconvention=as.character(tnc)
                       )
  return(init(retval))
} )

#'@rdname savR
#@aliases savR,missing-method
setMethod("savR", signature("missing"), function() { savR(".") })

subsetSide <- function(data, side) {
  if (side=="top") {
    data <- data[grepl(".1..", data$tile),]
  } else if (side=="bottom") {
    data <- data[grepl(".2..", data$tile),]
  }
  return(data)
}



#'@rdname plotIntensity
#@aliases plotIntensity,savProject,integer,character-method
setMethod("plotIntensity", signature(project="savProject", cycle="integer", base="character"), function(project, cycle=1L, base=c("A", "C", "G", "T")) {
  x <- y <- NULL
  if (cycle < 0)
    stop ("Cycle out of range")
  data <- project@parsedData[["savCorrectedIntensityFormat"]]@data
  if (is.null(data))
    stop("Corrected Intensity data not available")
  val <- paste("avg_cor_called", c("A", "C", "G", "T"), sep="_") 
  names(val) <- c("A", "C", "G", "T")
  maxInt <- max(c(data[, val["A"]], data[, val["C"]], data[, val["G"]], data[, val["T"]]))
  if(maxInt < 7000) {
    maxInt <= 7000
  }
  data <- data[data$cycle==cycle,]
  base <- match.arg(base)
  
  p <- qplot(factor(x),y,fill=get(val[base]), data=data, geom="tile", position="dodge", main = paste("Intensity: ", base, ", Cycle ", cycle, sep="")) + 
    theme_bw() + theme(legend.position = "bottom") + scale_fill_continuous(guide = guide_colorbar(title=val, barwidth=10), limits=c(0,maxInt) ) + 
    facet_grid(~lane, space="free", scales="free") + 
    xlab("") + ylab("") + scale_x_discrete(labels="") 
  gridExtra::grid.arrange(p)
} )

#'@rdname plotIntensity
#@aliases plotIntensity,savProject,missing,missing-method
setMethod("plotIntensity", signature(project="savProject", cycle="missing", base="missing"), function(project) { plotIntensity(project, 1L, "A")})
#'@rdname plotIntensity
#@aliases plotIntensity,savProject,integer,missing-method
setMethod("plotIntensity", signature(project="savProject", cycle="integer", base="missing"), function(project, cycle) { plotIntensity(project, cycle, "A")})
#'@rdname plotIntensity
#@aliases plotIntensity,savProject,missing,character-method
setMethod("plotIntensity", signature(project="savProject", cycle="missing", base="character"), function(project, base) { plotIntensity(project, 1L, base)})



#'@rdname plotFWHM
#@aliases plotFWHM,savProject,integer,character-method
setMethod("plotFWHM", signature(project="savProject", cycle="integer", base="character"), function(project, cycle=1L, base=c("A", "C", "G", "T")) {
  x <- y <- NULL
  if (cycle < 0)
    stop ("Cycle out of range")
  data <- project@parsedData[["savExtractionFormat"]]@data
  if (is.null(data))
    stop("Extraction data not available")
  data <- data[data$cycle==cycle,]
  base <- match.arg(base)
  val <- paste("FWHM", base, sep="_")
  p <- qplot(factor(x),y,fill=get(val), data=data, geom="tile", position="dodge", main = paste("Intensity: ", base, ", Cycle ", cycle, sep="")) + 
    theme_bw() + theme(legend.position = "bottom") + scale_fill_continuous(guide = guide_colorbar(title=val, barwidth=10), limits=c(0,10) ) +
    facet_grid(~lane, space="free", scales="free") +
    xlab("") + ylab("") + scale_x_discrete(labels="") 
  gridExtra::grid.arrange(p)
} )

#'@rdname plotFWHM
#@aliases plotFWHM,savProject,missing,missing-method
setMethod("plotFWHM", signature(project="savProject", cycle="missing", base="missing"), function(project) { plotFWHM(project, 1L, "A")})
#'@rdname plotFWHM
#@aliases plotFWHM,savProject,integer,missing-method
setMethod("plotFWHM", signature(project="savProject", cycle="integer", base="missing"), function(project, cycle) { plotFWHM(project, cycle, "A")})
#'@rdname plotFWHM
#@aliases plotFWHM,savProject,missing,character-method
setMethod("plotFWHM", signature(project="savProject", cycle="missing", base="character"), function(project, base) { plotFWHM(project, 1L, base)})

#Get formatted data for Q GT30 plot
#
#@param data data.frame
#@param cycle cycle
getFormatQGT30 <- function(data, cycle=1L) {
  #side <- match.arg(side)
  #data <- subsetSide(data,side)
  stats <- getFlowcellStats(data)
  contenders <- as.integer(gsub("Q", "", colnames(data)[grepl("^Q", colnames(data))]))
  lt30 <- paste("Q", 1:30, sep="")
  gte30 <- paste("Q", 31:max(contenders), sep="")
  return(cbind(data[data$cycle==cycle, c("cycle", "lane", "tile")], 
               x=factor(rep(1:(stats$nswath*stats$nsides*stats$nlanes), each=stats$ntiles)), 
               y=rep(1:stats$ntiles, stats$nswath*stats$nsides),
               gte30=apply(data[data$cycle==cycle,], 1, function(x) { 
                 return(sum(x[gte30])/(sum(x[c(lt30, gte30)])+.00001)*100 )
               })
  ))
}



#'@rdname plotQGT30
#@aliases plotQGT30,savProject,integer-method
setMethod("plotQGT30", signature(project="savProject", cycle="integer"), function(project, cycle=1L) {
  x <- y <- gte30 <- NULL
  if (cycle < 0)
    stop ("Cycle out of range")
  data <- project@parsedData[["savQualityFormat"]]@data
  if (is.null(data))
    stop("Quality data not available")
  cycleData <- getFormatQGT30(data, cycle)
  p <- qplot(x, y, fill=gte30, data=cycleData, geom="tile", position="dodge", main = paste("Percent Q>=30, Cycle ", cycle, sep="")) + 
    theme_bw() + theme(legend.position = "bottom") + scale_fill_continuous(guide = guide_colorbar(title="%Q>=30", barwidth=10), limits=c(0,100) ) +
    facet_grid(~lane, space="free", scales="free") +
    xlab("") + ylab("") + scale_x_discrete(labels="") 
  gridExtra::grid.arrange(p)
} )

#'@rdname plotQGT30
#@aliases plotQGT30,savProject,missing-method
setMethod("plotQGT30", signature(project="savProject", cycle="missing"), function(project) { plotQGT30(project, 1L)})



#'@rdname pfBoxplot
#@aliases pfBoxplot,savProject-method
setMethod("pfBoxplot", signature("savProject"), function(project) {
  lane <- value <- code <- NULL
  data <- project@parsedData[["savTileFormat"]]@data
  if (is.null(data))
    stop("Tile data not available")
  data <- data[data$code %in% c(100,101),]
  data[data$code==100, "code"] <- "Clusters"
  data[data$code==101, "code"] <- "PF"
  p <- ggplot2::ggplot(data, ggplot2::aes(factor(lane), value)) + ggplot2::geom_boxplot(notch=F, ggplot2::aes(fill = code), alpha=.8) + ggplot2::ylim(0,max(data$value)) +
    ggplot2::theme_bw() + ggplot2::theme(legend.position = "bottom") + 
    ggplot2::labs(list(y=expression(paste("Clusters/", mm^2, sep="")), x="Lane", fill=""))
  gridExtra::grid.arrange(p)
} )

#format quality data
#
#@param data data
#@param lane lane
#@param cycles cycles
#@return formatted data
qFormat <- function(data,lane,cycles,collapse=T) {
  data <- data[data$lane==lane & data$cycle %in% cycles, ]
  quals <- paste("Q", 1:50, sep="")
  mat <- reshape2::melt(data[,c("cycle",quals)], id=c("cycle"), measured=quals)
  mat <- reshape2::dcast(mat, cycle ~ variable, sum)
  mat <- reshape2::melt(mat, id=c("cycle"), measured=quals)
  mat[,2] <- as.numeric(gsub("Q", "", mat[,2]))
  colnames(mat) <- c("x", "y", "z")
  return(mat)
}

#read number to vector of cycle numbers
#
#@param project SAV project
#@param read read number
#@return vector of cycle numbers
readToCycles <- function(project, read) {
  cycles <- c()
  indexed <- c()
  for (x in project@reads) {
    cycles <- c(cycles, x@cycles)
    indexed <- c(indexed, x@index)
  }
  seqreadlen <- vector("integer", sum(!indexed))
  r <- 0
  for (i in 1:length(indexed)) {
    if (!indexed[i]) {
      r <- r + 1
    } 
    seqreadlen[r] <- seqreadlen[r] + cycles[i]      
  }
  start <- 1
  end <- 0
  result <- list()
  for (r in 1:length(seqreadlen)) {
    end <- end + seqreadlen[r]
    result[[r]] <- start:end
    start <- start + seqreadlen[r]
  }
  return(result[[read]])     
}



#'@rdname qualityHeatmap
#@aliases qualityHeatmap,savProject,integer,integer,logical-method
setMethod("qualityHeatmap", signature(project="savProject", lane="integer", read="integer", collapse="logical"), function(project, lane, read, collapse=T) {
  y <- z <- ..level.. <- NULL
  plots <- list()
  nsegments <- directions(project)
  if (!collapse)
    nsegments <- length(reads(project))
  # TODO: collapse segments
  if (!all( read %in% 1:nsegments))
    stop(paste("There are only", directions(project), "sequence read(s) and ", length(reads(project)), "total read segments on this flowcell, check read specification."))
  formatName <- names(project@parsedData)[pmatch("savQualityFormat", names(project@parsedData))]
  
  for (x in 1:length(read)) {
    mat <- qFormat(data=project@parsedData[[formatName]]@data, lane=lane, cycles=readToCycles(project, read[x]), collapse)
    plots[[x]] <- ggplot2::ggplot(mat, ggplot2::aes(x=x, y=y, z=z)) + 
      ggplot2::stat_contour(bins=50, geom="polygon", ggplot2::aes(fill=..level..)) + ggplot2::ylim(0,50) + 
      ggplot2::theme_bw() + ggplot2::scale_fill_gradient2(low="white", mid=scales::muted("green"), high="red", midpoint=quantile(mat$z, .99) ) + 
      xlab("cycle") + ylab("Q")
  }
  do.call(gridExtra::grid.arrange, c(plots, ncol=length(plots)))
} )

#'@rdname qualityHeatmap
#@aliases qualityHeatmap,savProject,numeric,numeric,missing-method
setMethod("qualityHeatmap", signature(project="savProject", lane="numeric", read="numeric", collapse="missing"), function(project, lane, read) { qualityHeatmap(project, as.integer(lane), as.integer(read), collapse=TRUE)})


#'@rdname buildReports
#@aliases buildReports,savProject,character-method
setMethod("buildReports", signature(project="savProject", destination="character"), function(project, destination="./savR-reports") {
  path <- location(project)
  if (!file.exists(path))
    stop(paste("Project", path, "does not exist."))
  reports <- normalizePath(destination, mustWork=F)
  if (file.exists(reports))
    stop(paste("Reports folder", reports, "already exists."))
  for (f in c("ByCycle", "ErrorRate", "FWHM", "Intensity", "NumGT30")) {
    assign(f, paste(reports, f, sep="/"))
    dir.create(get(f), showWarnings=F, recursive=T)
  }
  # PF plot
  Cairo::Cairo(file=paste(reports, "/NumClusters By Lane.png", sep=""), width=800, height=400, dpi=72, type="png", bg="white")
  pfBoxplot(project)
  dev.off()
  # intensity plots
  path <- normalizePath(paste(reports, "Intensity", sep="/"))
  for (cycle in 1:project@cycles) {
    for (base in c("A", "C", "G", "T")) {
      tryCatch({
        Cairo::Cairo(file=paste(path, "/Chart_", cycle, "_", tolower(base), ".png", sep=""), width=300, height=800, dpi=72, type="png", bg="white")
        plotIntensity(project, cycle, base)
        dev.off()},
        warning = function(w) {
          return()
        },
        error = function(e) {
          warning("Unable to create intensity plot for cycle ", cycle , " base ", base, ": ", geterrmessage())
        },
        finally = {
          try(dev.off(), silent=TRUE)
        })
    }
  }
  # Q>30 plots
  path <- normalizePath(paste(reports, "NumGT30", sep="/"))
  for (cycle in 1:project@cycles) {
    tryCatch({
      Cairo::Cairo(file=paste(path, "/Chart_", cycle, ".png", sep=""), width=300, height=800, dpi=72, type="png", bg="white")
      plotQGT30(project, cycle)
      dev.off()},
      warning = function(w) {
        return()
      },
      error = function(e) {
        warning("Unable to create Q>30 plot for cycle ", cycle, ": ", geterrmessage())
      },
      finally = {
        try(dev.off(), silent=TRUE)
      })
  }
  
  
  # plot lane quality
  path <- normalizePath(paste(reports, "ByCycle", sep="/"))
  for (lane in 1:project@layout@lanecount) {
    tryCatch({
      Cairo::Cairo(file=paste(path, "/QScore_L", lane, ".png", sep=""), width=800, height=400, dpi=72, type="png", bg="white")
      qualityHeatmap(project, lane, 1:project@directions)
      dev.off()},
      warning = function(w) {
        return()
      },
      error = function(e) {
        warning("Unable to create lane quality plot for lane ", lane, ": ", geterrmessage())
      },
      finally = {
        try(dev.off(), silent=TRUE)
      })
  } 
  
  # FWHM plots
  path <- normalizePath(paste(reports, "FWHM", sep="/"))
  for (cycle in 1:project@cycles) {
    for (base in c("A", "C", "G", "T")) {
      tryCatch({
        Cairo::Cairo(file=paste(path, "/Chart_", cycle, "_", tolower(base), ".png", sep=""), width=300, height=800, dpi=72, type="png", bg="white")
        plotFWHM(project, cycle, base)
        dev.off()},
        warning = function(w) {
          return()
        },
        error = function(e) {
          warning("Unable to create FWHM plot for cycle ", cycle, " base ", base, ": ", geterrmessage())
        },
        finally = {
          try(dev.off(), silent=TRUE)
        })
    }
  }  
  
} )

#'@rdname buildReports
#@aliases buildReports,savProject,missing-method
setMethod("buildReports", signature(project="savProject", destination="missing"), function(project) { buildReports(project, "./savR-reports")})


#Generic binary parser
#
#@param project SAV project
#@param format savFormat subclass to define data types
#@return sorted data.frame of parsed data)
parseBin <- function(project, format) {
  path <- getInterOpFilePath(project, format)
  fh <- file(path, "rb")
  vers <- readBin(fh, what="integer", endian="little", size=1, signed=F)
  if (vers != format@version) {
    close(fh)
    warning(paste(" the generic savR parser currently only supports version", format@version, "of this SAV file.", format@filename, "is reported as version", vers, "."))
    return(NULL)
  }
  reclen <- readBin(fh, what="integer", endian="little", size=1, signed=F)
  if (reclen != sum(format@lengths))
    stop(paste("file's declared record size (", reclen, ") does not equal formats declared size (", sum(format@lengths), ")"))
  
  data.f <- parseBinData(project,format,fh)
  
  close(fh)
  
  result <- new("savData", header=list(version=vers, record_length=reclen), data=data.f, accessor=format@accessor)
  
  return(result)
} 

parseBinData <- function(project, format, fh) {
  readlen <- 0
  for (x in project@reads) {
    readlen <- readlen + x@cycles
  }
  proj.size <- 0
  if (project@layout@tilenamingconvention == "FiveDigit") {
    proj.size <- project@layout@lanecount * project@layout@surfacecount *
      project@layout@swathcount * project@layout@sectionperlane *
      project@layout@lanepersection * project@layout@tilecount * readlen + 1
  } else {
    proj.size <- project@layout@lanecount * project@layout@surfacecount * 
      project@layout@swathcount * project@layout@tilecount * readlen + 1
  }
  data <- vector("list", proj.size)
  r <- 1
  while (!isIncomplete(fh)) {
    dat <- c()
    for (i in 1:length(format@lengths)) {
      if (format@type[i] != "integer") {
        dat <- c(dat, readBin(fh, what=format@type[i], size=format@lengths[i], endian="little"))
      } else if (format@type[i] == "integer" & format@lengths[i] == 2L) {
        dat <- c(dat, readBin(fh, what=format@type[i], size=format@lengths[i], endian="little", signed=F))
      } else {
        # R does not handle 32-bit unsigned int :/
        dat <- c(dat, readBin(fh, what=format@type[i], size=format@lengths[i], endian="little"))
      }
    }
    if (length(dat)==0)
      break
    if(length(dat) == length(format@lengths)) {
      data[[r]] <- dat
    } else {
      warning(format@filename, " prematurely terminated with incomplete row at ", r)
      break
    }
    r <- r + 1
  }
  # remove NULL rows
  data.f <- as.data.frame(do.call("rbind", data[!unlist(lapply(data, is.null))] ))
  colnames(data.f) <- format@name
  actnum <- length(unique(data.f[,"lane"]))
  if (format@filename == "ErrorMetricsOut.bin") {
    # no consistent way to determine which lanes were called?
  } else if (actnum != project@layout@lanecount) {
    stop(paste("number of lanes in data file (", actnum, ") does not equal project configuration value (", 
      project@layout@lanecount, ") when parsing ", format@filename, sep=""))
  }
  data.f <- data.f[do.call(order, as.list(data.f[,format@order])),]
  return(data.f)
}

#validParser <- function(object) {
#  if (length(object@format@name) != length(object@format@type) & length(object@format@type) != length(object@format@size))
#    return("length of format parameters are not equal.")
#  TRUE
#}

#setValidity("savParser", validParser)

#Get basic flowcell statistics
#
#used to get flowcell information when data object has
#lane, cycle, and tile data.
#
#@param data.frame of parsed data
#@return list of statistics
getFlowcellStats <- function(object) {
  retval <- list()
  retval$sides  <- as.numeric(substring(object$tile,1,1))
  retval$swaths <- as.numeric(substring(object$tile,2,2))
  retval$tiles  <- as.numeric(substring(object$tile,3,4))
  retval$nsides <- as.numeric(length(unique(substring(object$tile,1,1))))
  retval$nswath <- as.numeric(length(unique(substring(object$tile,2,2))))
  retval$ntiles <- as.numeric(substr(max(object$tile),3,4))
  retval$ncycle <- max(object$cycle)
  retval$nlanes <- max(object$lane)
  return(retval)
} 

#Add position data to parsed data
#
#Adds and x and a y column to parsed data.  These are used for
#laying out tiles in a tile plot.  Values are organized by
#lane, then by swath and surface.
#
#@param data data.frame of parsed data
#@return annotated data.frame
addPosition <- function(data) {
  ##< addPosition
  ### This is an internal method for annotating flowcell data with XY coordinates
  ### used in tile plots of flowcell lanes.
  stats <- getFlowcellStats(data)

  return(cbind(data, 
               x=( (data$lane-1) * (stats$nswath*stats$nside) + 1 ) + 
                 (stats$swaths-1) + 
                 ( (stats$sides-1) * stats$nsides + (stats$sides-1) ), 
               #y=rep(rep(1:stats$ntiles, stats$nswath*stats$nsides*stats$ncycle), stats$nlanes)
               y=stats$tiles
               ))
} 

#Do parsing
#
#After everything is configured, initialize parsing of SAV files.
#
#@param project SAV project
init <- function(project) {
  validFormats <- c("savCorrectedIntensityFormat", 
                    "savQualityFormat",
                    "savQualityFormatV5", 
                    "savTileFormat", 
                    "savExtractionFormat",
                    "savErrorFormat")
  
  fileSuccess <- list()
  
  for (x in validFormats) {
    format <- new(x)
    
    if (is.null(fileSuccess[[format@filename]])) {
      fileSuccess[format@filename] <- FALSE
    }
    
    filePath <- suppressWarnings(normalizePath(paste(project@location, "InterOp", format@filename, sep="/") ))
    
    if (file.exists(filePath)) {
      
      if (fileSuccess[format@filename] == TRUE || !testVersion(project,format)) next

      parsedData <- NULL
      data <- NULL
      success <- FALSE
      
      tryCatch({
        if (format@default == T) {
          parsedData <- parseBin(project, format)
        } else {
          f <- get(paste("parse", x, sep=""))
          parsedData <- f(project, format)
        }
        success <- TRUE
      },
      error = function(e) {
        warning("Unable to parse binary data: ", geterrmessage())
      },
      finally = {
      })
      
      if (success == FALSE) next
      
      fileSuccess[format@filename] <- success      
      
      data <- parsedData@data
      
      if (!is.null(data)) {
        # don't add position data to tiles
        if (class(format)[1] != "savTileFormat" )
          data <- addPosition(data)
        # removed unparsed date columns
        if (class(format)[1] == "savExtractionFormat")
          data <- data[,-c(12:13)]
      }
      
      parsedData@data <- data
      
      project@parsedData[[x]] <- parsedData
    }
  }
  return(project)
} 

#
# test the version of the file against the formatter
testVersion <- function(project, format) {
  matched <- FALSE
  path <- normalizePath(paste(project@location, "InterOp", format@filename, sep="/"))
  fh <- file(path, "rb")
  vers <- readBin(fh, what="integer", endian="little", size=1, signed=F)
  close(fh)
  if (length(vers) == 0) {
    warning(paste("Unable to determine file version: empty", format@filename, "binary file?", sep=" "))
    vers <- -1
  }
  if (vers == format@version) {
    matched <- TRUE 
  }
  return(matched)
}

getInterOpFilePath <- function(project, format) {
  return(normalizePath(paste(project@location, "InterOp", format@filename, sep="/")))
}

#
# taken from: https://tracker.tgac.ac.uk/browse/MISO-138
# 
# Quality Metrics (QMetricsOut.bin)
# Format:
#  byte 0: file version number (5)
#  byte 1: length of each record
#  byte 2: quality score binning (byte flag representing if binning was on), if (byte 2 == 1) // quality score binning on
#  byte 3: number of quality score bins, B
#  bytes 4 - (4+B-1): lower boundary of quality score bins
#  bytes (4+B) - (4+2*B-1): upper boundary of quality score bins
#  bytes (4+2*B) - (4+3*B-1): remapped scores of quality score bins
# The remaining bytes are for the records, with each record in this format:
#  2 bytes: lane number  (uint16)
#  2 bytes: tile number  (uint16)
#  2 bytes: cycle number (uint16)
#  4 x 50 bytes: number of clusters assigned score (uint32) Q1 through Q50
# Where N is the record index
#
#
# variable length header SAV Quality Formatter (version 5)
parsesavQualityFormatV5 <- function(project, format) {
  path <- getInterOpFilePath(project,format)
  fh <- file(path, "rb")
  vers <- readBin(fh, what="integer", endian="little", size=1, signed=F)
  reclen <- readBin(fh, what="integer", endian="little", size=1, signed=F)
  binning <- readBin(fh, what="integer", endian="little", size=1, signed=F)
  
  lowB <- c()
  upB <- c()
  remapB <- c()
  nBins <- 0
 
  if (binning == 1) { 
    nBins <- readBin(fh, what="integer", endian="little", size=1, signed=F)
    for (x in 1:nBins) {
      lowB <- c(lowB, readBin(fh, what="integer", endian="little", size=1, signed=F))
    }
    for (x in 1:nBins) {
      upB <- c(upB, readBin(fh, what="integer", endian="little", size=1, signed=F))
    }
    for (x in 1:nBins) {
      remapB <- c(remapB, readBin(fh, what="integer", endian="little", size=1, signed=F))
    }
  }
  
  # end header processing
  
  parsedData <- new("savData", 
                    header=list(version=vers, record_length=reclen, binning=binning, nBins=nBins,
                                           lowBound=lowB, upperBound=upB, remappedScores=remapB),
                    data=parseBinData(project,format,fh),
                    accessor=format@accessor)
  
  close(fh)
  
  return(parsedData)
  
}

#'@rdname clusterQualityGtN
#'@aliases clusterQualityGtN,savProject,integer,integer,integer
setMethod("clusterQualityGtN", signature(project="savProject", lane="integer", cycle="integer", n="integer"),
          function(project, lane, cycle, n=30L) {
            if (!all(lane %in% 1:flowcellLayout(project)@lanecount)) {
              stop(paste("lane" , lane, "is not consistent with number of lanes on flowcell (", flowcellLayout(project)@lanecount, ")", sep=" "))
            }
            qm <- qualityMetrics(project)
            qm <- qm[qm$lane == lane,]
            if (!all(cycle %in% 1:max(qm$cycle))) {
              stop(paste("cycles" , cycle, "is not consistent with number of cycles (", max(qm@cycle), ")", sep=" "))
            }
            qm <- qm[qm$cycle %in% cycle, paste("Q", 1:50, sep="")]
            
            tot <- sum(qm)
            
            return(sum(qm[,paste("Q", n:50, sep="")])/tot)
})

#'Parse Illumina Sequence Analysis Viewer files 
#' 
#'\tabular{ll}{
#'Package: \tab savR \cr
#'Type: \tab Package \cr
#'Version: \tab 1.7.5 \cr
#'Date: \tab 2015-07-28 \cr
#'License: \tab AGPL-3 \cr
#'LazyLoad: \tab yes \cr
#'}
#' 
#'Parse Illumina Sequence Analysis Viewer (SAV) 
#'files, access data, and generate QC plots.
#' 
#'@name savR-package
#'@docType package
#'@import methods ggplot2 reshape2 scales gridExtra XML
#'@title Parse and analyze Illumina SAV files
#'@author R. Brent Calder \email{brent.calder@@einstein.yu.edu}
#'@references For information about Illumina SAV, please refer to \cr \url{http://supportres.illumina.com/documents/documentation/software_documentation/sav/sequencinganalysisviewer_userguide_15020619c.pdf} \cr For other implementations (and inspiration) please see \cr \url{http://search.cpan.org/dist/Bio-IlluminaSAV/Bio/IlluminaSAV.pm} \cr \url{https://bitbucket.org/invitae/illuminate}
#'@keywords package
#' 
NULL

#'@rdname location
#'@aliases location,savProject-method
setMethod("location", signature(project="savProject"), function(project) project@location)

#'@rdname reads
#'@aliases reads,savProject-method
setMethod("reads", signature(project="savProject"), function(project) project@reads)

#'@rdname flowcellLayout
#'@aliases flowcellLayout,savProject-method
setMethod("flowcellLayout", signature(project="savProject"), function(project) project@layout)

#'@rdname run
#'@aliases run,savProject-method
setMethod("run", signature(project="savProject"), function(project) project@runid)

#'@rdname cycles
#'@aliases cycles,savProject-method
setMethod("cycles", signature(project="savProject"), function(project) project@cycles)

#'@rdname directions
#'@aliases directions,savProject-method
setMethod("directions", signature(project="savProject"), function(project) project@directions)

#'@rdname correctedIntensities
#'@aliases correctedIntensities,savProject-method
setMethod("correctedIntensities", signature(project="savProject"), function(project) { 
  tmp <- project@parsedData[["savCorrectedIntensityFormat"]]@data
  if (is.null(tmp)) return(tmp)
  return(tmp[,!colnames(tmp) %in% c("x", "y")]) 
})

#'@rdname qualityMetrics
#'@aliases qualityMetrics,savProject-method
setMethod("qualityMetrics", signature(project="savProject"), function(project) { 
  tmp <- project@parsedData[["savQualityFormat"]]@data
  if (is.null(tmp)) return(tmp)
  return(tmp[,!colnames(tmp) %in% c("x", "y")]) 
})

#'@rdname tileMetrics
#'@aliases tileMetrics,savProject-method
setMethod("tileMetrics", signature(project="savProject"), function(project) {
  tmp <- project@parsedData[["savTileFormat"]]@data
  return(tmp)
})

#'@rdname extractionMetrics
#'@aliases extractionMetrics,savProject-method
setMethod("extractionMetrics", signature(project="savProject"), function(project) { 
  tmp <- project@parsedData[["savExtractionFormat"]]@data
  if (is.null(tmp)) return(tmp)
  return(tmp[,!colnames(tmp) %in% c("x", "y")]) 
})

#'@rdname errorMetrics
#'@aliases errorMetrics,savProject-method
setMethod("errorMetrics", signature(project="savProject"), function(project) {
  tmp <- project@parsedData[["savErrorFormat"]]@data
  if (is.null(tmp)) return(tmp)
  return(tmp[,!colnames(tmp) %in% c("x", "y")])
})

#'@rdname clusters
#@aliases clusters,savProject,integer
setMethod("clusters", signature(project="savProject", lane="integer"), function(project, lane=1L) {
  if (!all(lane %in% 1:flowcellLayout(project)@lanecount)) {
    stop(paste("lane" , lane, "is not consistent with number of lanes on flowcell (", flowcellLayout(project)@lanecount, ")", sep=" "))
  }
  tm <- tileMetrics(project)
  return(sum(tm[tm$lane %in% lane & tm$code==102,]$value))
})

#'@rdname pfClusters
#'@aliases pfClusters,savProject,integer
setMethod("pfClusters", signature(project="savProject", lane="integer"), function(project, lane=1L) {
  if (!all(lane %in% 1:flowcellLayout(project)@lanecount)) {
    stop(paste("lane" , lane, "is not consistent with number of lanes on flowcell (", flowcellLayout(project)@lanecount, ")", sep=" "))
  }
  tm <- tileMetrics(project)
  return(sum(tm[tm$lane %in% lane & tm$code==103,]$value))
})

setMethod("show", "savProject", function(object) cat(class(object), "instance with", 
                                                     object@layout@lanecount, "lanes,", 
                                                     object@cycles, "total cycles, and",
                                                     length(reads(object)), "sequence reads (",
                                                     object@directions, "sequencing and ",
                                                     length(reads(object))-object@directions, "indexed reads ).\n",
                                                     if(object@layout@tilenamingconvention != "") { 
                                                       paste("Indicated tile naming convention: ",
                                                             object@layout@tilenamingconvention, ".\n", sep="")} else
                                                               {"Default naming convention.\n"},
                                                     "With InterOp data for:", 
                                                     paste(" ", names(object@parsedData), 
                                                           " (", 
                                                           sapply(names(object@parsedData), FUN = function(x) { 
                                                             x <- new(x); return(x@accessor)
                                                             }), ")\n", sep = ""), "\n")
)

#'Illumina read
#'
#'Class representation of the features of an Illumina sequencing read.
#' 
#'@section Slots:
#'\describe{
#'\item{\code{number}:}{the index of this read in sequencing}
#'\item{\code{cycles}:}{number of cycles in this read}
#'\item{\code{index}:}{logical representing whether or not this read is an index read}
#'}
setClass("illuminaRead",   slots=c(number="integer", 
                                   cycles="integer",
                                   index="logical"))

#'Layout of an Illumina flowcell
#'
#'Class representation of the features of an Illumina flow cell.
#' 
#'@section Slots:
#'\describe{
#'\item{\code{lanecount}:}{Number of lanes on the flowcell}
#'\item{\code{surfacecount}:}{Number of surfaces}
#'\item{\code{swathcount}:}{Number of imaging swaths}
#'\item{\code{tilecount}:}{Number of tiles per swath}
#'\item{\code{sectionperlane}:}{Number of sections per lane (NextSeq)}
#'\item{\code{lanepersection}:}{Number of lanes per section (NextSeq)}
#'\item{\code{tilenamingconvention}:}{Description of deviation from original formatting layout}
#'}
setClass("illuminaFlowCellLayout", slots=c(lanecount="integer", 
                                           surfacecount="integer", 
                                           swathcount="integer", 
                                           tilecount="integer",
                                           sectionperlane="integer",
                                           lanepersection="integer",
                                           tilenamingconvention="character"
                                           ))

#'Structure for holding parsed InterOp headers and data
#'
#'@section Slots:
#'\describe{
#'\item{\code{header}:}{list of parsed header values}
#'\item{\code{data}:}{data.frame of parsed values}
#'}
setClass("savData", slots=c(header="list", data="data.frame", accessor="character"),
         prototype=prototype(header=list(), data=NULL, accessor=NULL))

#'SAV project class
#' 
#'Represents a flowcell, metadata and parsed SAV information
#' 
#'@section Slots:
#'\describe{
#'\item{\code{location}:}{Full path to flowcell directory}
#'\item{\code{reads}:}{List of \link{illuminaRead-class}}
#'\item{\code{layout}:}{\link{illuminaFlowCellLayout-class}}
#'\item{\code{runid}:}{Run ID}
#'\item{\code{number}:}{Run number}
#'\item{\code{flowcell}:}{Flowcell ID}
#'\item{\code{instrument}:}{Instrument ID}
#'\item{\code{date}:}{Run date}
#'\item{\code{cycles}:}{Total number of cycles}
#'\item{\code{directions}:}{Total number of sequence runs (ends)}
#'\item{\code{parsedData}:}{SAV data}
#'}
setClass("savProject", 
         slots=c(location="character",	
                 reads="list", 
                 layout="illuminaFlowCellLayout", 
                 runid="character", 
                 number="integer", 
                 flowcell="character", 
                 instrument="character", 
                 date="character", 
                 cycles="integer", 
                 directions="integer", 
                 parsedData="list"), 
         prototype=prototype(location="."))

#'Base class for formatters
#'
#'Defines the necessary slots to create parse different binary files using
#'the same generic parser.
#'
#'@section Slots:
#'\describe{
#'\item{\code{name}:}{vector of column names}
#'\item{\code{type}:}{vector of data types of elements}
#'\item{\code{lengths}:}{vector of byte lengths for each element}
#'\item{\code{order}:}{vector of column names for sorting}
#'\item{\code{version}:}{integer version number}
#'\item{\code{default}:}{logical default format ()}
#'}
setClass("savFormat", slots=c(filename="character", 
                              name="character", 
                              type="character", 
                              lengths="integer", 
                              order="character", 
                              version="integer",
                              accessor="character",
                              default="logical"))

#'Corrected Intensity formatter
#'
#'Lane, tile, cycle, average intensity, corrected intensities (ACGT),
#'average corrected called intensities (ACGT), number of no-calls,
#'number of (ACGT) calls, and signal to noise ratio.
#'
#'@section Slots:
#'\describe{
#'\item{\code{name}:}{vector of column names}
#'\item{\code{type}:}{vector of data types of elements}
#'\item{\code{lengths}:}{vector of byte lengths for each element}
#'\item{\code{order}:}{vector of column names for sorting}
#'\item{\code{version}:}{integer version number}
#'}
setClass("savCorrectedIntensityFormat", contains="savFormat", 
         prototype=prototype(filename="CorrectedIntMetricsOut.bin", 
                             name=c("lane", "tile", "cycle", "avg_intensity", paste("avg_cor", c("A", "C", "G", "T"), sep="_"), 
                                    paste("avg_cor_called", c("A", "C", "G", "T"), sep="_"),
                                    paste("num", c("none", "A", "C", "G", "T"), sep="_"), 
                                    "sig_noise"),
                             type=c(rep("integer", 17), "numeric"),
                             lengths=c(rep(2L,12), rep(4L, 6)),
                             order=c("lane", "cycle", "tile"),
                             version=2L,
                             accessor="correctedIntensities",
                             default=TRUE))

#'Quality Metrics formatter
#'
#'Lane, tile, cycle, Q1-Q50 counts
#'
#'@section Slots:
#'\describe{
#'\item{\code{name}:}{vector of column names}
#'\item{\code{type}:}{vector of data types of elements}
#'\item{\code{lengths}:}{vector of byte lengths for each element}
#'\item{\code{order}:}{vector of column names for sorting}
#'\item{\code{version}:}{integer version number}
#'}
setClass("savQualityFormat", contains="savFormat", 
         prototype=prototype(filename="QMetricsOut.bin", 
                             name=c("lane", "tile", "cycle", paste("Q", 1:50, sep="")),
                             type=c(rep("integer", 53)),
                             lengths=c(rep(2L, 3), rep(4L, 50) ),
                             order=c("lane", "cycle", "tile"),
                             version=4L,
                             accessor="qualityMetrics",
                             default=TRUE))


#'Quality Metrics formatter version 5
#'
#'Lane, tile, cycle, Q1-Q50 counts
#'
#'@section Slots:
#'\describe{
#'\item{\code{name}:}{vector of column names}
#'\item{\code{type}:}{vector of data types of elements}
#'\item{\code{lengths}:}{vector of byte lengths for each element}
#'\item{\code{order}:}{vector of column names for sorting}
#'\item{\code{version}:}{integer version number}
#'}
#'
# Format information found at https://tracker.tgac.ac.uk/browse/MISO-138
# Quality Metrics (QMetricsOut.bin)
# Format:
# byte 0: file version number (5)
# byte 1: length of each record
# byte 2: quality score binning (byte flag representing if binning was on), if (byte 2 == 1) // quality score binning on
# byte 3: number of quality score bins, B
# // if byte 2 == 1
#   bytes 4 - (4+B-1): lower boundary of quality score bins
#   bytes (4+B) - (4+2*B-1): upper boundary of quality score bins
#   bytes (4+2*B) - (4+3*B-1): remapped scores of quality score bins
# The remaining bytes are for the records, with each record in this format:
# 2 bytes: lane number  (uint16)
# 2 bytes: tile number  (uint16)
# 2 bytes: cycle number (uint16)
# 4 x 50 bytes: number of clusters assigned score (uint32) Q1 through Q50
# Where N is the record index
setClass("savQualityFormatV5", contains="savFormat", 
         prototype=prototype(filename="QMetricsOut.bin", 
                             name=c("lane", "tile", "cycle", paste("Q", 1:50, sep="") ),
                             type=c(rep("integer", 53)),
                             lengths=c(2L, 2L, 2L, rep(4L, 50)),
                             order=c("lane", "cycle", "tile"),
                             accessor="qualityMetrics",
                             version=5L,
                             default=FALSE))

#'Tile Metrics formatter
#'
#'Lane, tile, code, value.  Codes are:
#'
#'\tabular{ll}{
#'100 \tab Cluster Density \cr
#'101 \tab PF Cluster Density \cr
#'102 \tab Number of clusters \cr
#'103 \tab Number of PF clusters \cr
#'400 \tab Control lane \cr
#'}
#'
#'@section Slots:
#'\describe{
#'\item{\code{name}:}{vector of column names}
#'\item{\code{type}:}{vector of data types of elements}
#'\item{\code{lengths}:}{vector of byte lengths for each element}
#'\item{\code{order}:}{vector of column names for sorting}
#'\item{\code{version}:}{integer version number (header consists of version (1b), length (1b))}
#'}
setClass("savTileFormat", contains="savFormat", 
         prototype=prototype(filename="TileMetricsOut.bin", 
                             name=c("lane", "tile", "code", "value"),
                             type=c(rep("integer", 3), "numeric"),
                             lengths=c(rep(2L, 3), 4L),
                             order=c("lane", "code", "tile"),
                             version=2L,
                             accessor="tileMetrics",
                             default=TRUE))

#'Extraction Metrics formatter
#'
#'Lane, tile, cycle, FWHM (ACGT), intensity (ACGT), datestamp, timestamp.
#'Datestamp and timestamp are munged at the moment because R does not 
#'have native support for 32-bit unsigned integers and I have not implemented 
#'a solution.
#'
#'@section Slots:
#'\describe{
#'\item{\code{name}:}{vector of column names}
#'\item{\code{type}:}{vector of data types of elements}
#'\item{\code{lengths}:}{vector of byte lengths for each element}
#'\item{\code{order}:}{vector of column names for sorting}
#'\item{\code{version}:}{integer version number}
#'}
setClass("savExtractionFormat", contains="savFormat", 
         prototype=prototype(filename="ExtractionMetricsOut.bin", 
                             name=c("lane", "tile", "cycle", 
                                    paste("FWHM", c("A", "C", "G", "T"), sep="_"), 
                                    paste("int", c("A", "C", "G", "T"), sep="_"), "datestamp", "timestamp"),
                             type=c(rep("integer", 3), rep("numeric", 4), rep("integer", 6)),
                             lengths=c(rep(2L, 3), rep(4L,4), rep(2L,4), rep(4L,2) ),
                             order=c("lane", "cycle", "tile"),
                             version=2L,
                             accessor="extractionMetrics",
                             default=TRUE))

#'Error Metrics formatter
#'
#'Lane, tile, cycle, errorrate, nPerfect, n1Error, n2Error,
#'n3Error, n4Error.
#'
#'@section Slots:
#'\describe{
#'\item{\code{name}:}{vector of column names}
#'\item{\code{type}:}{vector of data types of elements}
#'\item{\code{lengths}:}{vector of byte lengths for each element}
#'\item{\code{order}:}{vector of column names for sorting}
#'\item{\code{version}:}{integer version number}
#'}
setClass("savErrorFormat", contains="savFormat",
         prototype=prototype(filename="ErrorMetricsOut.bin",
                             name=c("lane", "tile", "cycle", "errorrate", "nPerfect", paste("n", 1:4, "Error", sep="")),
                             type=c(rep("integer", 3), "numeric", rep("integer", 5)),
                             lengths=c(rep(2L, 3), rep(4L, 6)),
                             order=c("lane", "cycle", "tile"),
                             version=3L,
                             accessor="errorMetrics",
                             default=TRUE))

setClass("savParser", slots=c(project="savProject", format="savFormat"))

#'Build a SAV project
#' 
#'Constructor to build a \link{savProject-class} object and populate it. A SAV 
#'project consists of binary files generated by an Illumina sequencing run
#'and placed in a folder named "InterOp". This folder contains a number
#'of ".bin" files that contain statistics about the run.  Creating
#'this object parses all of the files and makes the data available for analysis.
#' 
#'@param object String Path to Flowcell data
#'@export
#'@examples
#'fc <- savR(system.file("extdata", "MiSeq", package="savR"))
#'fc
#'
#'@rdname savR
setGeneric("savR", function(object) standardGeneric("savR"))

#'Get Flowcell folder location
#'
#'Accessor to obtain the path to data for a particular SAV project.
#'
#'@param project SAV project
#'@return normalized path to Illumina run data.
#'@export
#'@rdname location
#'@examples
#'example(savR)
#'location(fc)
setGeneric("location", function(project) standardGeneric("location"))

#'Get reads
#'
#'Accessor to obtain information about the reads of a particular Illumina
#'sequencing run.
#'
#'@param project SAV project
#'@return List of \link{illuminaRead-class} objects
#'@export
#'@rdname reads
#'@examples
#'example(savR)
#'reads(fc)
setGeneric("reads", function(project) standardGeneric("reads"))

#'Get flowcell layout
#'
#'Accessor to obtain information about the characteristics of the flowcell
#'from an Illumina sequencing run.
#'
#'@param project SAV project
#'@return \link{illuminaFlowCellLayout-class} object
#'@export
#'@rdname flowcellLayout
#'@examples
#'example(savR)
#'flowcellLayout(fc)
setGeneric("flowcellLayout", function(project) standardGeneric("flowcellLayout"))

#'Get the Run ID
#'
#'Accessor to obtain the string identifier of an Illumina sequencing run.
#'
#'@param project SAV project
#'@return parsed Illumina run id
#'@export
#'@rdname run
#'@examples
#'example(savR)
#'run(fc)
setGeneric("run", function(project) standardGeneric("run"))

#'Get the total number of cycles
#'
#'Accessor to obtain the total number of cycles sequenced in an Illumina sequencing run.
#'
#'@param project SAV project
#'@return total number of cycles in run, including all sequencing and index reads.
#'@export
#'@rdname cycles
#'@examples
#'example(savR)
#'cycles(fc)
setGeneric("cycles", function(project) standardGeneric("cycles"))

#'Get the number of sequence reads
#'
#'Returns the number of sequencing reads (excluding index reads).
#'
#'@param project SAV project
#'@return number of reads
#'@export
#'@rdname directions
#'@examples
#'example(savR)
#'directions(fc)
setGeneric("directions", function(project) standardGeneric("directions"))

#'Get Corrected Intensity data
#'
#'Returns a data frame of corrected intensity data.
#'
#' \describe{
#'  \item{\code{lane}:}{Lane number} \cr
#'  \item{\code{tile}:}{Tile ID} \cr
#'  \item{\code{cycle}:}{Cycle number} \cr
#'  \item{\code{avg_intensity}:}{Average intensity} \cr
#'  \item{\code{avg_cor_[ACGT]}:}{Average corrected intensity of channel A, C, G, or T} \cr
#'  \item{\code{avg_cor_called_[ACGT]}:}{Average corrected intensity for called clusters in channel A, C, G, or T} \cr
#'  \item{\code{num_\{none|[ACGT]\}}:}{Number of called bases for no-call, A, C, G, or T} \cr
#'  \item{\code{sig_noise}:}{Signal to noise ratio} \cr
#' }
#'
#'
#'@param project SAV project
#'@return sorted data.frame of CI data.
#'@export
#'@rdname correctedIntensities
#'@examples
#'example(savR)
#'colnames(correctedIntensities(fc))
setGeneric("correctedIntensities", function(project) standardGeneric("correctedIntensities"))

#'Get Quality Metrics data
#'
#'Quality metric by lane, tile and cycle.
#'
#' \describe{
#'  \item{\code{lane}:}{Lane number}
#'  \item{\code{tile}:}{Tile ID}
#'  \item{\code{cycle}:}{Cycle number}
#'  \item{\code{Q1-Q50}:}{Number of clusters with quality of indicated column}
#' }
#'
#'@param project SAV project
#'@return sorted data.frame of quality data
#'@export
#'@rdname qualityMetrics
#'@examples
#'example(savR)
#'colnames(qualityMetrics(fc))
setGeneric("qualityMetrics", function(project) standardGeneric("qualityMetrics"))

#'Get Tile Metrics
#'
#'Returns the Tile Metrics SAV data.  
#'
#'Metrics for each tile are encoded in the following format:
#'\tabular{ll}{
#'cluster density: \tab 100 \cr
#'PF cluster density: \tab 101 \cr
#'number of clusters: \tab 102 \cr
#'number of PF clusters: \tab 103 \cr
#'phasing for read N: \tab (200 + (N - 1) * 2) \cr
#'prephasing for read N: \tab (201 + (N - 1) * 2) \cr
#'percent aligned for read N: \tab (300 + N - 1) \cr
#'control lane: \tab 400 \cr
#'}
#'
#' \describe{
#'  \item{\code{lane}:}{Lane number}
#'  \item{\code{tile}:}{Tile ID}
#'  \item{\code{code}:}{Code described above}
#'  \item{\code{value}:}{Value for code key}
#' }
#'
#' 
#'@references
#'Codes for Tile Metrics were obtained from the Python Illuminate package: \cr
#'\url{https://bitbucket.org/invitae/illuminate}
#' 
#'
#'@param project SAV project
#'@return sorted data.frame of tile metrics
#'@export
#'@rdname tileMetrics
#'@examples
#'example(savR)
#'colnames(tileMetrics(fc))
setGeneric("tileMetrics", function(project) standardGeneric("tileMetrics"))

#'Get Extraction Metrics
#'
#'Extraction (intensity and FWHM) metrics for lane, tile, and cycle.
#'
#' \describe{
#'  \item{\code{lane}:}{Lane number}
#'  \item{\code{tile}:}{Tile ID}
#'  \item{\code{cycle}:}{Cycle number}
#'  \item{\code{FWHM_[ACGT]}:}{Full width at half maximum for A, C, G, or T}
#'  \item{\code{int_[ACGT]}:}{Intensity of channel A, C, G, or T}
#'  \item{\code{datestamp}:}{Time/date stamp}
#' }
#'
#'
#'@param project SAV project
#'@return sorted data.frame of Extraction metrics
#'@export
#'@rdname extractionMetrics
#'@examples
#'example(savR)
#'colnames(extractionMetrics(fc))
setGeneric("extractionMetrics", function(project) standardGeneric("extractionMetrics"))


#'Get Error Metrics
#'
#'Error metrics for lane, tile, and cycle.
#'
#' \describe{
#'  \item{\code{lane}:}{Lane number}
#'  \item{\code{tile}:}{Tile ID}
#'  \item{\code{cycle}:}{Cycle number}
#'  \item{\code{errorrate}:}{Error rate}
#'  \item{\code{nPerfect}:}{number of perfect reads}
#'  \item{\code{n[1-4]Error}:}{Number of reads with 1, 2, 3 and 4 errors}
#' }
#'
#'
#'@param project SAV project
#'@return sorted data.frame of Error metrics
#'@export
#'@rdname errorMetrics
#'@examples
#'example(savR)
#'colnames(extractionMetrics(fc))
setGeneric("errorMetrics", function(project) standardGeneric("errorMetrics"))

#'Plot flowcell intensity by base and cycle
#' 
#'Draws a representation of a flowcell, showing the average corrected called intensity values.
#' 
#'@param project A \link{savProject-class} object
#'@param cycle integer cycle number
#'@param base character for nucleotide
#' 
#'@export
#'@docType methods
#'@rdname plotIntensity
setGeneric("plotIntensity", function(project, cycle, base) standardGeneric("plotIntensity"))

#'Generate FWHM plots
#'
#'Plots the average full width of clusters at half maximum (FWHM) of each tile
#'for a given cycle and base.
#'
#'@param project SAV project
#'@param cycle sequence cycle
#'@param base nucleotide base (ACGT)
#'@export
#'@docType methods
#'@rdname plotFWHM
setGeneric("plotFWHM", function(project, cycle, base) standardGeneric("plotFWHM"))

#'Plot Quality > 30 for a flowcell
#'
#'Generate a plot for a given cycle of the percentage of clusters in each tile
#'that are >= Q30.
#'
#'@param project SAV project
#'@param cycle sequence cycle
#'@export
#'@docType methods
#'@rdname plotQGT30
setGeneric("plotQGT30", function(project, cycle) standardGeneric("plotQGT30"))

#'PF Boxplot
#'
#'Generate a boxplot of the numbers of clusters and the number of
#'Illumina pass-filter clusters per tile and lane
#'
#'@param project SAV project
#'@export 
#'@docType methods
#'@rdname pfBoxplot
setGeneric("pfBoxplot", function(project) standardGeneric("pfBoxplot"))

#'Generate a heatmap of qualities
#'
#'Plots a heatmap of quality vs cycle for a given lane for 1 or more sequence reads.  Read qualities include sequence + index.
#'
#'@param project SAV project
#'@param lane integer lane specification
#'@param read integer vector of sequence reads to include (not including index reads)
#'@param collapse whether or not to collapse index reads into the preceeding read (# reads = directions), default TRUE
#'@export
#'@docType methods
#'@rdname qualityHeatmap
setGeneric("qualityHeatmap", function(project, lane, read, collapse) standardGeneric("qualityHeatmap") )

#'Generate Illumina reports folder
#'
#'Generate a folder of images that approximates the format of the folder that 
#'was superceded by InterOp. Requires the Cairo package.
#'
#'@param project SAV project
#'@param destination path to save reports folder
#'@export
#'@docType methods
#'@rdname buildReports
#'@examples
#'\dontrun{
#'example(savR)
#'buildReports(fc, "reports")
#'}
setGeneric("buildReports", function(project, destination) standardGeneric("buildReports"))

#'Get number of clusters per lane
#'
#'Sum the total number of clusters for all tiles in the lane.
#'
#'@param project SAV project
#'@param lane lane(s) number
#'@export
#'@docType methods
#'@rdname clusters
#'@examples
#'\dontrun{
#'example(savR)
#'clusters(fc, 1L)
#'} 
setGeneric("clusters", function(project, lane) standardGeneric("clusters"))

#'Get number of PF clusters per lane
#'
#'Sum the total pass filter number of clusters for all tiles in the lane.
#'
#'@param project SAV project
#'@param lane lane(s) number
#'@export
#'@docType methods
#'@rdname pfClusters
#'@examples
#'\dontrun{
#'example(savR)
#'pfClusters(fc, 1L)
#'} 
setGeneric("pfClusters", function(project, lane) standardGeneric("pfClusters"))

#'Get the proportion of clusters over a specified quality threshold 
#'
#'Return the ratio of clusters with a quality score less than or equal to 
#'a specified value (n) for the requested lanes and cycles.
#'
#'@param project SAV project
#'@param lane lane(s) number
#'@param cycle cycle(s) number
#'@param n quality threshold
#'@export
#'@docType methods
#'@rdname clusterQualityGtN
#'@examples
#'\dontrun{
#'example(savR)
#'clusterQualityGtN(fc, 1L, 25L, 30L)
#'}
setGeneric("clusterQualityGtN", function(project, lane, cycle, n) standardGeneric("clusterQualityGtN"))

require(savR)
context("Load InterOp File Test")

# use skip_on_cran() for long running tests

# test for avaliablitily of example data in extdata folder
miseq_available <- function() {
  if (!file.exists(system.file("extdata", "MiSeq", package="savR"))) {
    skip("Example data not available")
  }
}

# data folder not included in built package, skip if missing
data_available <- function() {
  if (!file.exists("../data")) {
    skip("Test data folder not available")
  }
}

test_that("Load sample MiSeq data and check values", {
  miseq_available()
  fc <- savR(system.file("extdata", "MiSeq", package="savR"))
  expect_equivalent(run(fc)["Id"], "131030_M01243_0072_000000000-A58WM", label = "FCID check")
  expect_equal(cycles(fc), 82, label = "cycle count")
  expect_equal(directions(fc), 1, label = "directions")
  expect_equal(clusters(fc,1L),35470731, label="clusters")
})

test_that("Load sample HiSeq RapidRun (QMetricsOut.bin v5) data and check values", {
  skip_on_cran()
  data_available()
  fc <- savR("../data/BHF5GNADXX")
  expect_equivalent(run(fc)["Id"], "150115_SN7001401_0253_BHF5GNADXX", label = "FCID check")
  expect_equal(cycles(fc), 209, label = "cycle count")
  expect_equal(directions(fc), 2, label = "directions")
  expect_equal(clusters(fc,1L), 184790371, label="clusters")
})

test_that("Load empty qmetrics file", {
  data_available()
  expect_warning(fc <- savR("../data/EMPTY"), regexp="Unable to determine", label="Empty binary file")
})

test_that("Load sample MiSeq with ErrorMetricsOut.bin", {
  skip_on_cran()
  data_available()
  fc <- savR("../data/AAF39")
  expect_equal(dim(errorMetrics(fc)), c(700, 9))
})

test_that("Load ErrorMetrics with unreported lanes", {
  skip_on_cran()
  data_available()
  fc <- savR("../data/AC5J04ACXX")
})

test_that("Load NextSeq500 flowcell", {
  skip_on_cran()
  data_available()
  fc <- savR("../data/NextSeq")
  expect_equivalent(run(fc)["Id"], "150602_NEXTSEQ1_0018_H2LGHAFXX", label = "FCID check")
})

test_that("Load v5 qmetrics", {
  skip_on_cran()
  data_available()
  fc <- savR("../data/BC5CAHACXX")
  expect_true("savQualityFormatV5" %in% names(fc@parsedData), "loading savQualityFormatV5")
})

require(savR)
context("Data Accessor Test")

# use skip_on_cran() for long running tests

# test for avaliablitily of example data in extdata folder
miseq_available <- function() {
  if (!file.exists(system.file("extdata", "MiSeq", package="savR"))) {
    skip("Example data not available")
  }
}

# data folder not included in built package, skip if missing
data_available <- function() {
  if (!file.exists("../data")) {
    skip("Test data folder not available")
  }
}

test_that("data accessors", {
  miseq_available()
  fc <- savR(system.file("extdata", "MiSeq", package="savR"))
  expect_equal(dim(correctedIntensities(fc)), c(3116, 18), label = "correctedIntensities")
  expect_equal(dim(qualityMetrics(fc)), c(3116, 53), label = "qualityMetrics")
  expect_equal(dim(tileMetrics(fc)), c(648, 4), label = "tileMetrics")
  expect_equal(dim(extractionMetrics(fc)), c(3116, 11), label = "extractionMetrics")
})

test_that("errorMetrics", {
  skip_on_cran()
  data_available()
  fc <- savR("../data/AAF39")
  expect_equal(dim(errorMetrics(fc)), c(700, 9), label = "errorMetrics")
})

\documentclass[letterpaper,11pt,oneside,final,onecolumn,article]{memoir}
\usepackage{microtype}
\usepackage{helvet}
\usepackage{pxfonts}
\usepackage{eulervm}
\usepackage{nicefrac}
\usepackage{graphicx}
\usepackage{textcomp}
\usepackage[numbers,square,comma,sort&compress]{natbib}
\usepackage{soul, color, ulem} % underline, overstrike, highlight 
\usepackage{amssymb}
\usepackage{hyperref} % URL's
\usepackage{memhfixc} % should have loaded already, memoir bugs

\setlrmarginsandblock{.75in}{.75in}{1}
\setulmarginsandblock{.75in}{.75in}{1}
\checkandfixthelayout

\pagestyle{empty}

\renewcommand{\abstractname}{} % no ``abstract''
\renewcommand{\bibname}{} % no ``bibliography''

\setsecheadstyle{\Large\sffamily\raggedright}
\setsubsecheadstyle{\large\sffamily\raggedright}
\setsubsubsecheadstyle{\normalsize\sffamily\raggedright}

%\VignetteIndexEntry{Using savR}

\begin{document}

\fvset{listparameters={\setlength{\topsep}{0pt}}} 
\renewenvironment{Schunk}{\vspace{\topsep}}{\vspace{\topsep}} 
\renewenvironment{Schunk}{\vspace{5pt}}{\vspace{5pt}} 

\title{Using savR}
\author{R. Brent Calder}

\maketitle

<<prepare>>=
library(savR)
@

<<intro,cache=T>>=
fc <- savR(system.file("extdata", "MiSeq", package="savR"))
@

<<show>>=
fc
@

<<doPfPlot,eval=F>>=
pfBoxplot(fc)
@
<<pfPlot,echo=F>>=
png(filename="pf.png", width=400, height=300, res=72)
pfBoxplot(fc)
invisible(dev.off())
@

\begin{figure}[htb]
\begin{center}
\includegraphics[width=3in]{pf.png}
\end{center}
\caption{Boxplot of total vs. PF clusters}
\label{fig:fp}
\end{figure}

\section*{Introduction}

The Illumina Sequence Analysis Viewer (SAV) is a Windows application provided by Illumina that 
presents graphs made in real time from data collected over the course of basecalling.  This data was 
previously also made available in HTML format for inspection after the run; however, it is now
preserved in binary format and not simply parsed by users who wish to perform automated quality
assessment.  Here is presented \textit{savR}, an R package to parse the binary output, generate 
QC assessment plots and make the data available to users of Illumina sequencing instruments.
For more information about Illumina SAV, please consult the Illumina iCom website and the
Sequencing Analysis Viewer User's Guide, available
\href{https://duckduckgo.com/?q=sequencing%20analysis%20viewer%20user%27s%20guide}{\textit{online}}.

\section*{Description}

The \texttt{savR} function is passed a path to an Illumina HiSeq or MiSeq run, and returns a
\texttt{savProject} object, containing the parsed data.  Accessor methods are available for
information in the \texttt{RunInfo.xml} file as well as the parsed SAV Metrics files.  These include
corrected intensities, quality metrics, tile metrics, and extraction metrics.  The \textit{savR}
package comes with an example MiSeq data set which can be loaded thusly:

<<intro2,eval=F>>=
fc <- savR(system.file("extdata", "MiSeq", package="savR"))
@

\subsection*{RunInfo.xml}

The \texttt{RunInfo.xml} file is parsed and stored in the slots of the \texttt{savProject} object.
There are accessor methods for the project's \texttt{location}, \texttt{reads}, number of ``ends'' 
or \texttt{directions}, the \texttt{run} ID, the number of \texttt{cycles}, and a description of
the \texttt{flowcellLayout}.

<<ri>>=
directions(fc)
reads(fc)
cycles(fc)
flowcellLayout(fc)
@

\subsection*{Corrected intensitites}

Corrected intensity metrics (obtained from \texttt{CorrectedIntMetricsOut.bin}) can be inspected
by the \texttt{correctedIntestites} accessor method:

<<ciex>>=
head(correctedIntensities(fc), n=1)
@

This is a \texttt{data.frame} of intensity metrics; one line for each set of lane, tile and cycle 
measurements. Reported statistics include average intensity, corrected intensity (for cross-talk between 
bases and phasing/pre-phasing), called corrected intensities, number of called bases and signal to
noise ratio.  There are methods which act upon \texttt{savProject} objects to produce QC plots, for example 
plotIntensity to assess signal intensity for each channel as in figure \ref{fig:ci}.

<<doCiPlot,eval=F>>=
plotIntensity(fc)
@

<<ciPlot,echo=F>>=
png(filename="ci.png", width=250, height=400, res=72)
plotIntensity(fc)
invisible(dev.off())
@

\begin{figure}[htb]
\begin{center}
\includegraphics[width=2.25in]{ci.png}
\end{center}
\caption{Corrected intensity plot: cycle 1, base ``A''.}
\label{fig:ci}
\end{figure}

\subsection*{Quality Metrics}

The quality metrics (\texttt{QMetricsOut.bin}) file contains per-lane/tile/cycle metrics for the number
of clusters with quality at each PHRED value from 1-50.


<<qmex>>=
head(qualityMetrics(fc), n=1)
@

<<doQhPlot,eval=F>>=
qualityHeatmap(fc,1,1)
@

<<qhPlot,echo=F>>=
png(filename="qh.png", width=400, height=300, res=72)
qualityHeatmap(fc,1,1)
invisible(dev.off())
@

\begin{figure}[h]
\begin{center}
\includegraphics[width=3.5in]{qh.png}
\end{center}
\caption{Quality heatmap: lane 1, read 1.}
\label{fig:qh}
\end{figure}

\subsection*{Tile Metrics}

The tile metrics (\texttt{TileMetricsOut.bin}) file contains coded information about per-lane/cycle/tile cluster density,
pass-filter clusters, phasing and pre-phasing data.  Consult the \texttt{tileMetrics} help page for more information.

<<tmex>>=
head(tileMetrics(fc), n=4)
@

\subsection*{Extraction Metrics}

The extraction metrics (\texttt{ExtractionMetricsOut.bin}) file contains per-lane/cycle/tile information about per-base FWHM
(full width pixel size of clusters at half maximum) and 90th \%-ile intensity of signal intensity.

<<example2>>=
head(extractionMetrics(fc), n=1)
@

\section*{Coda}

There is a convenience function (\texttt{buildReports}), which partially reconstructs the Illumina reports folder
that was previously generated by the Illumina instrument software and which was superseded by SAV and InterOp files.





\end{document}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/SavR-accessors.R
\docType{methods}
\name{extractionMetrics}
\alias{extractionMetrics}
\alias{extractionMetrics,savProject-method}
\title{Get Extraction Metrics}
\usage{
extractionMetrics(project)

\S4method{extractionMetrics}{savProject}(project)
}
\arguments{
\item{project}{SAV project}
}
\value{
sorted data.frame of Extraction metrics
}
\description{
Extraction (intensity and FWHM) metrics for lane, tile, and cycle.
}
\details{
\describe{
 \item{\code{lane}:}{Lane number}
 \item{\code{tile}:}{Tile ID}
 \item{\code{cycle}:}{Cycle number}
 \item{\code{FWHM_[ACGT]}:}{Full width at half maximum for A, C, G, or T}
 \item{\code{int_[ACGT]}:}{Intensity of channel A, C, G, or T}
 \item{\code{datestamp}:}{Time/date stamp}
}
}
\examples{
example(savR)
colnames(extractionMetrics(fc))
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/savR-methods.R
\docType{methods}
\name{plotFWHM}
\alias{plotFWHM}
\alias{plotFWHM,savProject,integer,character-method}
\alias{plotFWHM,savProject,integer,missing-method}
\alias{plotFWHM,savProject,missing,character-method}
\alias{plotFWHM,savProject,missing,missing-method}
\title{Generate FWHM plots}
\usage{
plotFWHM(project, cycle, base)

\S4method{plotFWHM}{savProject,integer,character}(project, cycle = 1L,
  base = c("A", "C", "G", "T"))

\S4method{plotFWHM}{savProject,missing,missing}(project)

\S4method{plotFWHM}{savProject,integer,missing}(project, cycle)

\S4method{plotFWHM}{savProject,missing,character}(project, base)
}
\arguments{
\item{project}{SAV project}

\item{cycle}{sequence cycle}

\item{base}{nucleotide base (ACGT)}
}
\description{
Plots the average full width of clusters at half maximum (FWHM) of each tile
for a given cycle and base.
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/SavR-accessors.R
\docType{methods}
\name{reads}
\alias{reads}
\alias{reads,savProject-method}
\title{Get reads}
\usage{
reads(project)

\S4method{reads}{savProject}(project)
}
\arguments{
\item{project}{SAV project}
}
\value{
List of \link{illuminaRead-class} objects
}
\description{
Accessor to obtain information about the reads of a particular Illumina
sequencing run.
}
\examples{
example(savR)
reads(fc)
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/SavR-accessors.R
\docType{methods}
\name{qualityMetrics}
\alias{qualityMetrics}
\alias{qualityMetrics,savProject-method}
\title{Get Quality Metrics data}
\usage{
qualityMetrics(project)

\S4method{qualityMetrics}{savProject}(project)
}
\arguments{
\item{project}{SAV project}
}
\value{
sorted data.frame of quality data
}
\description{
Quality metric by lane, tile and cycle.
}
\details{
\describe{
 \item{\code{lane}:}{Lane number}
 \item{\code{tile}:}{Tile ID}
 \item{\code{cycle}:}{Cycle number}
 \item{\code{Q1-Q50}:}{Number of clusters with quality of indicated column}
}
}
\examples{
example(savR)
colnames(qualityMetrics(fc))
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/SavR-accessors.R
\docType{methods}
\name{clusters}
\alias{clusters}
\alias{clusters,savProject,integer-method}
\title{Get number of clusters per lane}
\usage{
clusters(project, lane)

\S4method{clusters}{savProject,integer}(project, lane = 1L)
}
\arguments{
\item{project}{SAV project}

\item{lane}{lane(s) number}
}
\description{
Sum the total number of clusters for all tiles in the lane.
}
\examples{
\dontrun{
example(savR)
clusters(fc, 1L)
}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/savR-methods.R
\docType{methods}
\name{buildReports}
\alias{buildReports}
\alias{buildReports,savProject,character-method}
\alias{buildReports,savProject,missing-method}
\title{Generate Illumina reports folder}
\usage{
buildReports(project, destination)

\S4method{buildReports}{savProject,character}(project,
  destination = "./savR-reports")

\S4method{buildReports}{savProject,missing}(project)
}
\arguments{
\item{project}{SAV project}

\item{destination}{path to save reports folder}
}
\description{
Generate a folder of images that approximates the format of the folder that
was superceded by InterOp. Requires the Cairo package.
}
\examples{
\dontrun{
example(savR)
buildReports(fc, "reports")
}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{savQualityFormatV5-class}
\alias{savQualityFormatV5-class}
\title{Quality Metrics formatter version 5}
\description{
Lane, tile, cycle, Q1-Q50 counts
}
\section{Slots}{

\describe{
\item{\code{name}:}{vector of column names}
\item{\code{type}:}{vector of data types of elements}
\item{\code{lengths}:}{vector of byte lengths for each element}
\item{\code{order}:}{vector of column names for sorting}
\item{\code{version}:}{integer version number}
}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/SavR-accessors.R
\docType{methods}
\name{errorMetrics}
\alias{errorMetrics}
\alias{errorMetrics,savProject-method}
\title{Get Error Metrics}
\usage{
errorMetrics(project)

\S4method{errorMetrics}{savProject}(project)
}
\arguments{
\item{project}{SAV project}
}
\value{
sorted data.frame of Error metrics
}
\description{
Error metrics for lane, tile, and cycle.
}
\details{
\describe{
 \item{\code{lane}:}{Lane number}
 \item{\code{tile}:}{Tile ID}
 \item{\code{cycle}:}{Cycle number}
 \item{\code{errorrate}:}{Error rate}
 \item{\code{nPerfect}:}{number of perfect reads}
 \item{\code{n[1-4]Error}:}{Number of reads with 1, 2, 3 and 4 errors}
}
}
\examples{
example(savR)
colnames(extractionMetrics(fc))
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/SavR-accessors.R
\docType{methods}
\name{run}
\alias{run}
\alias{run,savProject-method}
\title{Get the Run ID}
\usage{
run(project)

\S4method{run}{savProject}(project)
}
\arguments{
\item{project}{SAV project}
}
\value{
parsed Illumina run id
}
\description{
Accessor to obtain the string identifier of an Illumina sequencing run.
}
\examples{
example(savR)
run(fc)
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/SavR-accessors.R
\docType{methods}
\name{location}
\alias{location}
\alias{location,savProject-method}
\title{Get Flowcell folder location}
\usage{
location(project)

\S4method{location}{savProject}(project)
}
\arguments{
\item{project}{SAV project}
}
\value{
normalized path to Illumina run data.
}
\description{
Accessor to obtain the path to data for a particular SAV project.
}
\examples{
example(savR)
location(fc)
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/SavR-accessors.R
\docType{methods}
\name{flowcellLayout}
\alias{flowcellLayout}
\alias{flowcellLayout,savProject-method}
\title{Get flowcell layout}
\usage{
flowcellLayout(project)

\S4method{flowcellLayout}{savProject}(project)
}
\arguments{
\item{project}{SAV project}
}
\value{
\link{illuminaFlowCellLayout-class} object
}
\description{
Accessor to obtain information about the characteristics of the flowcell
from an Illumina sequencing run.
}
\examples{
example(savR)
flowcellLayout(fc)
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{savData-class}
\alias{savData-class}
\title{Structure for holding parsed InterOp headers and data}
\description{
Structure for holding parsed InterOp headers and data
}
\section{Slots}{

\describe{
\item{\code{header}:}{list of parsed header values}
\item{\code{data}:}{data.frame of parsed values}
}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/savR-methods.R
\docType{methods}
\name{clusterQualityGtN}
\alias{clusterQualityGtN}
\alias{clusterQualityGtN,savProject,integer,integer,integer}
\alias{clusterQualityGtN,savProject,integer,integer,integer-method}
\title{Get the proportion of clusters over a specified quality threshold}
\usage{
clusterQualityGtN(project, lane, cycle, n)

\S4method{clusterQualityGtN}{savProject,integer,integer,integer}(project, lane,
  cycle, n = 30L)
}
\arguments{
\item{project}{SAV project}

\item{lane}{lane(s) number}

\item{cycle}{cycle(s) number}

\item{n}{quality threshold}
}
\description{
Return the ratio of clusters with a quality score less than or equal to
a specified value (n) for the requested lanes and cycles.
}
\examples{
\dontrun{
example(savR)
clusterQualityGtN(fc, 1L, 25L, 30L)
}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/savR-methods.R
\docType{methods}
\name{savR}
\alias{savR}
\alias{savR,character-method}
\alias{savR,missing-method}
\title{Build a SAV project}
\usage{
savR(object)

\S4method{savR}{character}(object)

\S4method{savR}{missing}()
}
\arguments{
\item{object}{String Path to Flowcell data}
}
\description{
Constructor to build a \link{savProject-class} object and populate it. A SAV
project consists of binary files generated by an Illumina sequencing run
and placed in a folder named "InterOp". This folder contains a number
of ".bin" files that contain statistics about the run.  Creating
this object parses all of the files and makes the data available for analysis.
}
\examples{
fc <- savR(system.file("extdata", "MiSeq", package="savR"))
fc
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{savCorrectedIntensityFormat-class}
\alias{savCorrectedIntensityFormat-class}
\title{Corrected Intensity formatter}
\description{
Lane, tile, cycle, average intensity, corrected intensities (ACGT),
average corrected called intensities (ACGT), number of no-calls,
number of (ACGT) calls, and signal to noise ratio.
}
\section{Slots}{

\describe{
\item{\code{name}:}{vector of column names}
\item{\code{type}:}{vector of data types of elements}
\item{\code{lengths}:}{vector of byte lengths for each element}
\item{\code{order}:}{vector of column names for sorting}
\item{\code{version}:}{integer version number}
}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{savFormat-class}
\alias{savFormat-class}
\title{Base class for formatters}
\description{
Defines the necessary slots to create parse different binary files using
the same generic parser.
}
\section{Slots}{

\describe{
\item{\code{name}:}{vector of column names}
\item{\code{type}:}{vector of data types of elements}
\item{\code{lengths}:}{vector of byte lengths for each element}
\item{\code{order}:}{vector of column names for sorting}
\item{\code{version}:}{integer version number}
\item{\code{default}:}{logical default format ()}
}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/SavR-accessors.R
\docType{methods}
\name{cycles}
\alias{cycles}
\alias{cycles,savProject-method}
\title{Get the total number of cycles}
\usage{
cycles(project)

\S4method{cycles}{savProject}(project)
}
\arguments{
\item{project}{SAV project}
}
\value{
total number of cycles in run, including all sequencing and index reads.
}
\description{
Accessor to obtain the total number of cycles sequenced in an Illumina sequencing run.
}
\examples{
example(savR)
cycles(fc)
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/savR-methods.R
\docType{methods}
\name{plotQGT30}
\alias{plotQGT30}
\alias{plotQGT30,savProject,integer-method}
\alias{plotQGT30,savProject,missing-method}
\title{Plot Quality > 30 for a flowcell}
\usage{
plotQGT30(project, cycle)

\S4method{plotQGT30}{savProject,integer}(project, cycle = 1L)

\S4method{plotQGT30}{savProject,missing}(project)
}
\arguments{
\item{project}{SAV project}

\item{cycle}{sequence cycle}
}
\description{
Generate a plot for a given cycle of the percentage of clusters in each tile
that are >= Q30.
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/SavR-accessors.R
\docType{methods}
\name{directions}
\alias{directions}
\alias{directions,savProject-method}
\title{Get the number of sequence reads}
\usage{
directions(project)

\S4method{directions}{savProject}(project)
}
\arguments{
\item{project}{SAV project}
}
\value{
number of reads
}
\description{
Returns the number of sequencing reads (excluding index reads).
}
\examples{
example(savR)
directions(fc)
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{savProject-class}
\alias{savProject-class}
\title{SAV project class}
\description{
Represents a flowcell, metadata and parsed SAV information
}
\section{Slots}{

\describe{
\item{\code{location}:}{Full path to flowcell directory}
\item{\code{reads}:}{List of \link{illuminaRead-class}}
\item{\code{layout}:}{\link{illuminaFlowCellLayout-class}}
\item{\code{runid}:}{Run ID}
\item{\code{number}:}{Run number}
\item{\code{flowcell}:}{Flowcell ID}
\item{\code{instrument}:}{Instrument ID}
\item{\code{date}:}{Run date}
\item{\code{cycles}:}{Total number of cycles}
\item{\code{directions}:}{Total number of sequence runs (ends)}
\item{\code{parsedData}:}{SAV data}
}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/savR-methods.R
\docType{methods}
\name{qualityHeatmap}
\alias{qualityHeatmap}
\alias{qualityHeatmap,savProject,integer,integer,logical-method}
\alias{qualityHeatmap,savProject,numeric,numeric,missing-method}
\title{Generate a heatmap of qualities}
\usage{
qualityHeatmap(project, lane, read, collapse)

\S4method{qualityHeatmap}{savProject,integer,integer,logical}(project, lane,
  read, collapse = T)

\S4method{qualityHeatmap}{savProject,numeric,numeric,missing}(project, lane,
  read)
}
\arguments{
\item{project}{SAV project}

\item{lane}{integer lane specification}

\item{read}{integer vector of sequence reads to include (not including index reads)}

\item{collapse}{whether or not to collapse index reads into the preceeding read (# reads = directions), default TRUE}
}
\description{
Plots a heatmap of quality vs cycle for a given lane for 1 or more sequence reads.  Read qualities include sequence + index.
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{illuminaFlowCellLayout-class}
\alias{illuminaFlowCellLayout-class}
\title{Layout of an Illumina flowcell}
\description{
Class representation of the features of an Illumina flow cell.
}
\section{Slots}{

\describe{
\item{\code{lanecount}:}{Number of lanes on the flowcell}
\item{\code{surfacecount}:}{Number of surfaces}
\item{\code{swathcount}:}{Number of imaging swaths}
\item{\code{tilecount}:}{Number of tiles per swath}
\item{\code{sectionperlane}:}{Number of sections per lane (NextSeq)}
\item{\code{lanepersection}:}{Number of lanes per section (NextSeq)}
\item{\code{tilenamingconvention}:}{Description of deviation from original formatting layout}
}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{illuminaRead-class}
\alias{illuminaRead-class}
\title{Illumina read}
\description{
Class representation of the features of an Illumina sequencing read.
}
\section{Slots}{

\describe{
\item{\code{number}:}{the index of this read in sequencing}
\item{\code{cycles}:}{number of cycles in this read}
\item{\code{index}:}{logical representing whether or not this read is an index read}
}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/SavR-accessors.R
\docType{methods}
\name{correctedIntensities}
\alias{correctedIntensities}
\alias{correctedIntensities,savProject-method}
\title{Get Corrected Intensity data}
\usage{
correctedIntensities(project)

\S4method{correctedIntensities}{savProject}(project)
}
\arguments{
\item{project}{SAV project}
}
\value{
sorted data.frame of CI data.
}
\description{
Returns a data frame of corrected intensity data.
}
\details{
\describe{
 \item{\code{lane}:}{Lane number} \cr
 \item{\code{tile}:}{Tile ID} \cr
 \item{\code{cycle}:}{Cycle number} \cr
 \item{\code{avg_intensity}:}{Average intensity} \cr
 \item{\code{avg_cor_[ACGT]}:}{Average corrected intensity of channel A, C, G, or T} \cr
 \item{\code{avg_cor_called_[ACGT]}:}{Average corrected intensity for called clusters in channel A, C, G, or T} \cr
 \item{\code{num_\{none|[ACGT]\}}:}{Number of called bases for no-call, A, C, G, or T} \cr
 \item{\code{sig_noise}:}{Signal to noise ratio} \cr
}
}
\examples{
example(savR)
colnames(correctedIntensities(fc))
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/savR-package.R
\docType{package}
\name{savR-package}
\alias{savR-package}
\title{Parse and analyze Illumina SAV files}
\description{
Parse Illumina Sequence Analysis Viewer files
}
\details{
\tabular{ll}{
Package: \tab savR \cr
Type: \tab Package \cr
Version: \tab 1.7.5 \cr
Date: \tab 2015-07-28 \cr
License: \tab AGPL-3 \cr
LazyLoad: \tab yes \cr
}

Parse Illumina Sequence Analysis Viewer (SAV)
files, access data, and generate QC plots.
}
\author{
R. Brent Calder \email{brent.calder@einstein.yu.edu}
}
\references{
For information about Illumina SAV, please refer to \cr \url{http://supportres.illumina.com/documents/documentation/software_documentation/sav/sequencinganalysisviewer_userguide_15020619c.pdf} \cr For other implementations (and inspiration) please see \cr \url{http://search.cpan.org/dist/Bio-IlluminaSAV/Bio/IlluminaSAV.pm} \cr \url{https://bitbucket.org/invitae/illuminate}
}
\keyword{package}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/SavR-accessors.R
\docType{methods}
\name{tileMetrics}
\alias{tileMetrics}
\alias{tileMetrics,savProject-method}
\title{Get Tile Metrics}
\usage{
tileMetrics(project)

\S4method{tileMetrics}{savProject}(project)
}
\arguments{
\item{project}{SAV project}
}
\value{
sorted data.frame of tile metrics
}
\description{
Returns the Tile Metrics SAV data.
}
\details{
Metrics for each tile are encoded in the following format:
\tabular{ll}{
cluster density: \tab 100 \cr
PF cluster density: \tab 101 \cr
number of clusters: \tab 102 \cr
number of PF clusters: \tab 103 \cr
phasing for read N: \tab (200 + (N - 1) * 2) \cr
prephasing for read N: \tab (201 + (N - 1) * 2) \cr
percent aligned for read N: \tab (300 + N - 1) \cr
control lane: \tab 400 \cr
}

\describe{
 \item{\code{lane}:}{Lane number}
 \item{\code{tile}:}{Tile ID}
 \item{\code{code}:}{Code described above}
 \item{\code{value}:}{Value for code key}
}
}
\examples{
example(savR)
colnames(tileMetrics(fc))
}
\references{
Codes for Tile Metrics were obtained from the Python Illuminate package: \cr
\url{https://bitbucket.org/invitae/illuminate}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/savR-methods.R
\docType{methods}
\name{pfBoxplot}
\alias{pfBoxplot}
\alias{pfBoxplot,savProject-method}
\title{PF Boxplot}
\usage{
pfBoxplot(project)

\S4method{pfBoxplot}{savProject}(project)
}
\arguments{
\item{project}{SAV project}
}
\description{
Generate a boxplot of the numbers of clusters and the number of
Illumina pass-filter clusters per tile and lane
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{savExtractionFormat-class}
\alias{savExtractionFormat-class}
\title{Extraction Metrics formatter}
\description{
Lane, tile, cycle, FWHM (ACGT), intensity (ACGT), datestamp, timestamp.
Datestamp and timestamp are munged at the moment because R does not
have native support for 32-bit unsigned integers and I have not implemented
a solution.
}
\section{Slots}{

\describe{
\item{\code{name}:}{vector of column names}
\item{\code{type}:}{vector of data types of elements}
\item{\code{lengths}:}{vector of byte lengths for each element}
\item{\code{order}:}{vector of column names for sorting}
\item{\code{version}:}{integer version number}
}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/savR-methods.R
\docType{methods}
\name{plotIntensity}
\alias{plotIntensity}
\alias{plotIntensity,savProject,integer,character-method}
\alias{plotIntensity,savProject,integer,missing-method}
\alias{plotIntensity,savProject,missing,character-method}
\alias{plotIntensity,savProject,missing,missing-method}
\title{Plot flowcell intensity by base and cycle}
\usage{
plotIntensity(project, cycle, base)

\S4method{plotIntensity}{savProject,integer,character}(project, cycle = 1L,
  base = c("A", "C", "G", "T"))

\S4method{plotIntensity}{savProject,missing,missing}(project)

\S4method{plotIntensity}{savProject,integer,missing}(project, cycle)

\S4method{plotIntensity}{savProject,missing,character}(project, base)
}
\arguments{
\item{project}{A \link{savProject-class} object}

\item{cycle}{integer cycle number}

\item{base}{character for nucleotide}
}
\description{
Draws a representation of a flowcell, showing the average corrected called intensity values.
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{savTileFormat-class}
\alias{savTileFormat-class}
\title{Tile Metrics formatter}
\description{
Lane, tile, code, value.  Codes are:
}
\details{
\tabular{ll}{
100 \tab Cluster Density \cr
101 \tab PF Cluster Density \cr
102 \tab Number of clusters \cr
103 \tab Number of PF clusters \cr
400 \tab Control lane \cr
}
}
\section{Slots}{

\describe{
\item{\code{name}:}{vector of column names}
\item{\code{type}:}{vector of data types of elements}
\item{\code{lengths}:}{vector of byte lengths for each element}
\item{\code{order}:}{vector of column names for sorting}
\item{\code{version}:}{integer version number (header consists of version (1b), length (1b))}
}
}
